/**
@mainpage dKingyo Mersenne Twister Library
@section how_to_use g
@code
#define INDEPENDENT_DKC_MT
#include "dkcMTRand.h"
#ifdef dkcdMultiThread
#	ifdef NDEBUG
#		pragma comment(lib,"dkingyoMTDLLMT.dll")
#	else
#		pragma comment(lib,"dkingyoMTDLLMTd.dll")
#	endif
#else
#	ifdef NDEBUG
#		pragma comment(lib,"dkingyoMTDLLd.dll")
#	else
#		pragma comment(lib,"dkingyoMTDLL.dll")
#	endif
#endif
@endcode
@section src_source \[X

<ul>
<li>fast Mersenne Twister routine for Pentium4 / http://homepage1.nifty.com/herumi/gogo_e.html / Artistic Licence
<li>mt19937ar.c mt19937-64.c / http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/mt.html / BSD Licence
</ul>

@section change Ϗ
-# mymt2005
-# mymt.dsp̃vWFNgt@CɕύXB
-# D݂Ƀ\[X̍\ȂB
-# 64bitłMersenne Twister̃\[XtB 
-# DLL`ɂB

@section licence CZX
NYSLƂ܂B<br>
҂ւ̕񍐂΁ARт܂AǂCuɂȂł傤B<br>
񍐂ȂĂAppĂ܂܂񂵁AςĂ܂܂B<br>
<br>
܂ÃCuɂ͗lXȃ\[XR[hɐ삳܂B<br>
ꂼ̃CZXɏ]ȂĂ͂ȂȂ߂̃Cugpč\tgɂ
ȉ̕ȂǂɊ܂߂ĂB

<br>
<PRE>
dKingyo Mersenne Twister Library Copyright(C) d All rights reserved.
-----------------------------------------------------------------------
mt19937ar.c
   Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
   All rights reserved.
   
mt19937-64.c
   Copyright (C) 2004, Makoto Matsumoto and Takuji Nishimura,
   All rights reserved.                          
                          

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:

     1. Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.

     2. Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution.

     3. The names of its contributors may not be used to endorse or promote 
        products derived from this software without specific prior written 
        permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-----------------------------------------------------------------------
	fast Mersenne Twister routine for Pentium4
	2003/5/1
	MITSUNARI Shigeo(herumi@nifty.com)
	original source is http://www.math.keio.ac.jp/matumoto/emt.html
-----------------------------------------------------------------------
</PRE>
<br>
܂<br>
<br>
<br>
*/
#include "cpu_x86.h"
#include "dkcMTRand32.h"
#include "dkcMTRand64.h"


