/**
@author d
@file os.h
@brief osZNg
@since 2005/01/18
a
*/


#ifndef DKUTIL_CSTD_OS_H
#define DKUTIL_CSTD_OS_H



#if defined(WIN32) || defined(_WIN32) || defined(__WIN32__)
#	ifndef WIN32
#		define WIN32
#	endif

//for 32bit
#ifndef _WIN32_IE
#	define _WIN32_IE    0x0200
#endif
#ifndef _WIN32_WINNT
#	define _WIN32_WINNT 0x0400
#endif
#ifndef WINVER
#	define WINVER       0x0400
#endif
#define WIN32_LEAN_AND_MEAN 
#define NOMINMAX
#define OEMRESOURCE

#ifndef POINTER_64
#	define POINTER_64
#endif

#	include <windows.h>
#undef _WIN32_IE    
#undef _WIN32_WINNT 
#undef WINVER
#undef WIN32_LEAN_AND_MEAN 
#undef NOMINMAX
#undef OEMRESOURCE
#undef POINTER_64

#include <stddef.h>
#else

#include "stddef.h"

#endif

#include "define.h"

///dkutil_cstdpboolean
#ifndef BOOL
#	define BOOL int
#endif
#ifndef TRUE
#	define TRUE 1
#endif
#ifndef FALSE
#	define FALSE 0
#endif


//^` define.hōsقǂ̂낤
/*
typedef unsigned long uint32;
typedef unsigned short uint16;
typedef unsigned char uint8;

typedef long int32;
typedef short int16;
typedef char int8;
*/






#ifdef WIN32


typedef ULARGE_INTEGER DKC_UINT64_STRUCT;
typedef LARGE_INTEGER DKC_INT64_STRUCT;


#else

#ifndef ULONGLONG
#	define ULONGLONG unsigned long long int
#endif

#ifndef LONGLONG
#	define LONGLONG long long int
#endif

///64bit̍\ @note ACĂ鎖




typedef union dkc_s64bit_struct {
//#ifdef __cplusplus
  struct {
      uint32 LowPart;
      int32 HighPart;
  };
//#else
  struct {
      uint32 LowPart;
      int32 HighPart;
  }u;
//#endif
  LONGLONG QuadPart;
} DKC_INT64_STRUCT;


typedef union dkc_u64bit_struct {
//#ifdef __cplusplus
  struct {
      uint32 LowPart;
      uint32 HighPart;
  };
//#else
  struct {
      uint32 LowPart;
      uint32 HighPart;
  } u;
//#endif
  ULONGLONG QuadPart;
} DKC_UINT64_STRUCT;

#endif //end of WIN32

#ifndef uint64
#	define uint64 ULONGLONG
#endif
#ifndef int64
#	define int64 LONGLONG
#endif



/*
WX^TCYint
http://members.at.infoseek.co.jp/zzyyb/scm/hack/compiler.html

#ifdef _MSC_VER //VC
#	define register_int int

#elif defined(__BCPLUSPLUS__) || defined(__BORLANDC__) || \
	defined(__TCPLUSPLUS__) || defined(__TURBOC__) //BCC

#	ifdef __MSDOS__ //16bit
#		define register_int short


#	elif defined(WIN32) || defined(__WIN32__)// 32bit
#		define register_int int
#	elif defined(WIN64) || defined(__WIN64__)//64bit
#		define register_int long //maybe
#	endif
#else //other compiler
#	if defined(WIN16)
#		define register_int int16
#	elif defined(WIN32)
#		define register_int int32
#	elif defined(WIN64)
#		define register_int int64
#	endif


#endif

#define register_uint unsigned register_int
*/
#endif //end of include once

